package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLVertex_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLVertex extends JNIObject  {
	
	/* @generated */
	protected ISLVertex(long ptr) {
		/*** PROTECTED REGION ID(ISLVertex_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLVertex build(long ptr) {
		return new ISLVertex(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLVertex_userCode) ENABLED START ***/
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_vertex_get_ctx 
	 * 
	 * @generated
	**/
	public ISLContext getContext() {
		/*** PROTECTED REGION ID(isl_vertex_get_ctx) DISABLED START ***/
		ISLContext res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLContext.build(ISLNative.isl_vertex_get_ctx(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_vertex_get_id 
	 * 
	 * @generated
	**/
	public int getID() {
		/*** PROTECTED REGION ID(isl_vertex_get_id) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_vertex_get_id(getNativePtr(this));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_vertex_free 
	 * 
	 * @take this
	 * @generated
	**/
	public void free() {
		/*** PROTECTED REGION ID(isl_vertex_free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				ISLNative.isl_vertex_free(getNativePtr(this));
			} finally {
				taken(this);
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_vertex_get_domain 
	 * 
	 * @generated
	**/
	public ISLBasicSet getDomain() {
		/*** PROTECTED REGION ID(isl_vertex_get_domain) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLBasicSet.build(ISLNative.isl_vertex_get_domain(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_vertex_get_expr 
	 * 
	 * @generated
	**/
	public ISLMultiAff getExpr() {
		/*** PROTECTED REGION ID(isl_vertex_get_expr) DISABLED START ***/
		ISLMultiAff res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLMultiAff.build(ISLNative.isl_vertex_get_expr(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLVertex_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
